%define	tclvers		8.0.5
%define tclXvers	8.0.4
%define	expvers		5.28
%define	itclvers	3.0.1

Summary: A Tcl development environment: tcl, tclX, expect, and itcl.
Name: tcl-suite
Version: %{tclvers}
Release: 44tr
Source0: ftp://ftp.scriptics.com/pub/tcl/tcl8_0/tcl%{tclvers}.tar.gz
Source2: ftp://ftp.cme.nist.gov/pub/expect/expect.tar.gz
Source3: ftp://ftp.neosoft.com/pub/tcl/TclX/tclX%{tclXvers}.tar.gz
Source5: ftp://ftp.tcltk.com/pub/itcl/itcl%{itclvers}.tar.gz
Patch0: tcltk-8.0-ieee.patch
Patch1: tcl8.0.3-glibc21.patch
Patch2: tcl8.0.5-sigpwr.patch
Patch10: expect-5.24-mkpasswd.patch
Patch11: expect-5.26-alpha.patch
Patch12: expect-5.26-glibc21.patch
Patch13: expect-5.28-jbj.patch
Patch30: tclX-8.0.4-jbj.patch
Patch31: tclX-runtcl.patch
Patch32: expect-autopasswd.patch
Patch33: itcl3.0.1-tclonly.patch
License: BSD
Group: Programming/Interpreters
Buildroot: /var/tmp/%{name}-root
Obsoletes: tcltk

%description
Tcl is a simple scripting language designed to be embedded into other
applications.  Tk is removed to enable the package to work without X11,
hence the name of the package also lacking the Tk part.

%package -n tcl
#Version: 8.0.3
Summary: An embeddable scripting language.
Group: Programming/Interpreters
URL: http://www.scriptics.com

%description -n tcl
Tcl is a simple scripting language designed to be embedded into other
applications.  This package also includes tclsh, a simple example of 
a Tcl application.

If you're installing the tcl package and you want to use Tcl for
development, you should also install the tclx package.

%package -n expect
Version: %{expvers}
Summary: A tcl extension for simplifying program-script interaction.
Group: Programming/Interpreters

%description -n expect
Expect is a tcl extension for automating interactive applications such
as telnet, ftp, passwd, fsck, rlogin, tip, etc.  Expect is also useful
for testing those applications.  Expect makes it easy for a script to
control another program and interact with it.

Install the expect package if you'd like to develop scripts which
interact with interactive applications.  You'll also need to install
the tcl package.

%package -n tclx
#Version: 8.0.3
Summary: Tcl/Tk extensions for POSIX systems.
Group: Programming/Interpreters
URL: http://www.neosoft.com/

%description -n tclx
TclX is a set of extensions which make it easier to use the Tcl
scripting language for common UNIX/Linux programming tasks.  TclX
enhances Tcl support for files, network access, debugging, math,
lists, and message catalogs.  TclX can be used with both Tcl and
Tcl/Tk applications.

Install TclX if you are developing applications with tcl.  You'll
also need to install the tcl package.

%package -n itcl
Version: %{itclvers}
Summary: Object-oriented mega-widgets for Tcl.
Group: Programming/Interpreters

%description -n itcl
[incr Tcl] is an object-oriented extension of the Tcl language and was
created to support more structured programming in Tcl.  Tcl scripts
longer than a few thousand lines become extremely difficult to
maintain because the building blocks of vanilla Tcl are procedures and
global variables. All of these building blocks must reside in a single
global namespace and there is no support for protection or
encapsulation.

To help out with this problem, [incr Tcl] introduces the notion of
objects.  Each object is a bag of data with a set of procedures or
"methods" that are used to manipulate it.  Objects are organized into
"classes" with identical characteristics, and classes can inherit
functionality from one another.  This object-oriented paradigm adds
another level of organization on top of the basic variable/procedure
elements, and the resulting code is easier to understand and
maintain.

Install itcl if you're programming with Tcl, and you need the
object-oriented functionality that [incr Tcl] can provide.

%prep

#%setup -q -c -a 1 -a 2 -a 3 -a 4 -a 5
%setup -q -c -a 2 -a 3 -a 5

cd tcl%{tclvers}
#%patch0 -p2 -b .ieee
%patch1 -p2 -b .glibc21
%patch2 -p2 -b .sigpwr
cd ..

cd expect-%{expvers}
%patch10 -p2 -b .mkpasswd
%patch11 -p2 -b .alpha
%patch12 -p2 -b .glibc21
%patch13 -p2 -b .jbj
%patch32 -p2 -b .autopasswd
cd ..

cd tclX%{tclXvers}
%patch30 -p2 -b .wrongtclXvers
cd ..
# OK, this really touches both expect & tclX
%patch31 -p1 -b .runtcl

cd itcl%{itclvers}
%patch33 -p1 -b .tclonly
cd ..

# XXX this was only needed with the IEEE patch0
#cd tcl%{tclvers}/unix
#autoconf
#cd ../../
#cd tk%{tclvers}/unix
#autoconf

#==========================================
%build

# make the libraries reentrant
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -D_REENTRANT"

#------------------------------------------
# Tcl
#
cd tcl%{tclvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared --enable-gcc

%configure --enable-shared --enable-gcc
make
cd ../..

#----------------------------------- ------
# tclX
#
cd tclX%{tclXvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared

%configure --enable-shared --enable-gcc --disable-tk
make
cd ../..

#------------------------------------------
# Expect
#
cd expect-%{expvers}
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr

%configure --enable-shared --enable-gcc --with-tclconfig=../tcl%{tclvers}/unix --with-tclinclude=../tcl%{tclvers}/generic 

# XXX drill out HAVE_OPENPTY for now
perl -pi -e 's,HAVE_OPENPTY,HAVE_OPENPTY_BUT_DONT_USE_IT,g' expect_cf.h || :
# XXX drill in HAVE_PTMX for now
perl -pi -e 's,/* #undef HAVE_PTMX */,#define HAVE_PTMX 1,g' expect_cf.h || :

make Makefile

# XXX drill out HAVE_OPENPTY for now
perl -pi -e 's,HAVE_OPENPTY,HAVE_OPENPTY_BUT_DONT_USE_IT,g' expect_cf.h || :
# XXX drill in HAVE_PTMX for now
perl -pi -e 's,/* #undef HAVE_PTMX */,#define HAVE_PTMX 1,g' expect_cf.h || :

make

cd ..

#------------------------------------------
# itcl
#
cd itcl%{itclvers}
#libtoolize --copy --force
#./configure --prefix=/usr --enable-shared

%configure --enable-shared --exec-prefix=/foo --enable-gcc
make
cd ..

#==========================================
%install

rm -rf $RPM_BUILD_ROOT
rm -fv *.files*

mkdir -p $RPM_BUILD_ROOT/usr

#------------------------------------------
# Tcl
#
cd tcl%{tclvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtcl8.0.so $RPM_BUILD_ROOT/usr/lib/libtcl.so
ln -sf tclsh8.0 $RPM_BUILD_ROOT/usr/bin/tclsh
mkdir -p $RPM_BUILD_ROOT/usr/share
cp -af $RPM_BUILD_ROOT/usr/man $RPM_BUILD_ROOT/usr/share/
rm -Rf $RPM_BUILD_ROOT/usr/man
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/share/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | sort > tcl.files

#------------------------------------------
# TclX
#
cd tclX%{tclXvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
#ln -sf libtkx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtkx.so
ln -sf libtclx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtclx.so
mkdir -p $RPM_BUILD_ROOT/usr/share
cp -af $RPM_BUILD_ROOT/usr/man $RPM_BUILD_ROOT/usr/share/
rm -Rf $RPM_BUILD_ROOT/usr/man
cd ../..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/share/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files \
	| sort | uniq -u > tclx.files

#------------------------------------------
# Expect
#
cd expect-%{expvers}
make install prefix=$RPM_BUILD_ROOT/usr \
             bindir=$RPM_BUILD_ROOT/usr/bin \
             infodir=$RPM_BUILD_ROOT/usr/share/info \
             libdir=$RPM_BUILD_ROOT/usr/lib/expect-5.28 \
             tcl_libdir=$RPM_BUILD_ROOT/usr/lib \
             mandir=$RPM_BUILD_ROOT/usr/share/man \
             includedir=$RPM_BUILD_ROOT/usr/include
cd ..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/share/man -type f -o -type l;
find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tclx.files \
	| sort | uniq -u > expect.files

# for files in expect.files, sed the #! at the top...
for n in `cat expect.files`; do
	if head -1 $n | grep '#!'; then
		cp -af $n $n.in
		chmod u+w $n
		sed "s|$RPM_BUILD_ROOT||" < $n.in > $n
		rm -f $n.in
	fi
done

#------------------------------------------
# itcl
#
cd itcl%{itclvers}
make INSTALL_ROOT=$RPM_BUILD_ROOT exec_prefix=/usr install
#ln -sf libitk3.0.so $RPM_BUILD_ROOT/usr/lib/libitk.so
ln -sf libitcl3.0.so $RPM_BUILD_ROOT/usr/lib/libitcl.so
mkdir -p $RPM_BUILD_ROOT/usr/share
cp -af $RPM_BUILD_ROOT/usr/man $RPM_BUILD_ROOT/usr/share/
rm -Rf $RPM_BUILD_ROOT/usr/man
cd ..
(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/share/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tclx.files expect.files tix.files \
	| sort | uniq -u > itcl.files

for n in `cat itcl.files`; do
        if head -1 $n | grep '#!'; then
                cp -af $n $n.in
		chmod u+w $n
                sed "s|$RPM_BUILD_ROOT||" < $n.in > $n
		rm -f $n.in
        fi
done

#------------------------------------------
# this is too annoying to watch
set +x
for n in *.files; do
	mv $n $n.in
	sed "s|.*/usr|/usr|" < $n.in | while read file; do
	    if [ -d $RPM_BUILD_ROOT/$file ]; then
		echo -n '%dir '
	    fi
	    echo $file
	done > $n
	rm -f $n.in
done
set -x

#Strip the binaries
strip $RPM_BUILD_ROOT/usr/bin/* || :

# Man pages can be compressed
for file in *.files ; do 
    mv $file $file.in
    sed -e 's|/usr/share/man/man.*$|&\*|' < $file.in > $file
    rm -f $file.in
done

# Remove files in expect depending on expectk - Not pretty.
grep -v tknewsbiff expect.files | grep -v tkpasswd |grep -v xpstat > expect.files.tmp
mv expect.files.tmp expect.files

#==========================================
%post -p /sbin/ldconfig -n tcl
%post -p /sbin/ldconfig -n expect
%post -p /sbin/ldconfig -n tclx
%post -p /sbin/ldconfig -n itcl

%postun -p /sbin/ldconfig -n tcl
%postun -p /sbin/ldconfig -n expect
%postun -p /sbin/ldconfig -n tclx
%postun -p /sbin/ldconfig -n itcl

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
rm -f *.files*

%files -f tcl.files -n tcl
%defattr(-,root,root)
%files -f tclx.files -n tclx
%defattr(-,root,root)
%files -f expect.files -n expect
%defattr(-,root,root)
%files -f itcl.files -n itcl
%defattr(-,root,root)

%changelog
* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 8.0.5-44tr
- Fixed License
- Added %%defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 8.0.5-43tr
- Big rebuild.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 
- Rebuilt against glibc 2.3.2.

* Wed Jun 13 2001 Oystein Viggen <oysteivi at trustix dot com>
- Make the manpage-move-hack work with newer fileutils

* Wed May 31 2000 Oystein Viggen <oysteivi at trustix dot com>
- Make expect not require expectk

* Sun Apr 16 2000 Oystein Viggen <oysteivi at trustix dot com>
- Remove tk and tix as there is no X11 in TSL.

* Wed Mar 29 2000 Lars Gaarden <larsg at trustix dot com>
- Moved man pages to /usr/share, FHS.

* Thu Feb 03 2000 Elliot Lee <sopwith@redhat.com>
- Make changes from bug number 7602
- Apply patch from bug number 7537
- Apply fix from bug number 7157
- Add fixes from bug #7601 to the runtcl patch

* Wed Feb 02 2000 Cristian Gafton <gafton@redhat.com>
- fix descriptions
- man pages are compressed (whatapain)

* Tue Nov 30 1999 Jakub Jelinek <jakub@redhat.com>
- fix tclX symlinks.
- compile on systems where SIGPWR == SIGLOST.

* Sat May  1 1999 Jeff Johnson <jbj@redhat.com>
- update tcl/tk to 8.0.5.
- avoid "containing" in Tix (#2332).

* Thu Apr  8 1999 Jeff Johnson <jbj@redhat.com>
- use /usr/bin/write in kibitz (#1320).
- use cirrus.sprl.umich.edu in weather (#1926).

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 28)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- whoops, exec-prefix for itcl was set to '/foo', changed to '/usr'.

* Tue Feb 16 1999 Jeff Johnson <jbj@redhat.com>
- expect does unaligned access on alpha (#989)
- upgrade tcl/tk/tclX to 8.0.4
- upgrade expect to 5.28.
- add itcl 3.0.1

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize to allow building on the arm
- build for glibc 2.1
- strip binaries

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update tcl/tk/tclX to 8.0.3, expect is updated also.

* Mon Jun 29 1998 Jeff Johnson <jbj@redhat.com>
- expect: mkpasswd needs delay before sending password (problem #576)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed expect binaries exec permissions

* Thu Apr 09 1998 Erik Troan <ewt@redhat.com>
- updated to Tix 4.1.0.006
- updated version numbers of tcl/tk to relflect includsion of p2

* Wed Mar 25 1998 Cristian Gafton <gafton@redhat.com>
- updated tcl/tk to patch level 2
- updated tclX to 8.0.2

* Thu Oct 30 1997 Otto Hammersmith <otto@redhat.com>
- fixed filelist for tix... replacing path to the expect binary in scripts
  was leaving junk files around.

* Wed Oct 22 1997 Otto Hammersmith <otto@redhat.com>
- added patch to remove libieee test in configure.in for tcl and tk.
  Shoudln't be needed anymore for glibc systems, but this isn't the "proper" 
  solution for all systems
- fixed src urls

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- removed version numbers from descriptions

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>
- updated to tcl/tk 8.0 and related versions of packages

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc
- fixed dangling tclx/tkx symlinks
